*** ./src/backend/commands/trigger.c.orig	2010-08-28 17:15:25.000000000 +0100
--- ./src/backend/commands/trigger.c	2010-09-01 16:58:12.000000000 +0100
***************
*** 150,159 ****
  	 */
  	rel = heap_openrv(stmt->relation, ShareRowExclusiveLock);
  
! 	if (rel->rd_rel->relkind != RELKIND_RELATION)
  		ereport(ERROR,
  				(errcode(ERRCODE_WRONG_OBJECT_TYPE),
! 				 errmsg("\"%s\" is not a table",
  						RelationGetRelationName(rel))));
  
  	if (!allowSystemTableMods && IsSystemRelation(rel))
--- 150,198 ----
  	 */
  	rel = heap_openrv(stmt->relation, ShareRowExclusiveLock);
  
! 	if (rel->rd_rel->relkind == RELKIND_RELATION)
! 	{
! 		/* Forbid INSTEAD OF triggers on tables */
! 		if (stmt->instead)
! 			ereport(ERROR,
! 					(errcode(ERRCODE_WRONG_OBJECT_TYPE),
! 					 errmsg("\"%s\" is a table",
! 							RelationGetRelationName(rel)),
! 					 errhint("Define INSTEAD OF triggers on views")));
! 	}
! 	else if (rel->rd_rel->relkind == RELKIND_VIEW)
! 	{
! 		/* Only allow INSTEAD OF or STATEMENT-level triggers on views */
! 		if (!stmt->instead && stmt->row)
! 			ereport(ERROR,
! 					(errcode(ERRCODE_WRONG_OBJECT_TYPE),
! 					 errmsg("\"%s\" is a view",
! 							RelationGetRelationName(rel)),
! 					 errhint("Define ROW-level BEFORE and AFTER triggers on tables")));
! 
! 		/* Disallow STATEMENT-level INSTEAD OF triggers */
! 		if (stmt->instead && !stmt->row)
! 			ereport(ERROR,
! 					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 					 errmsg("STATEMENT-level INSTEAD OF triggers are not supported"),
! 					 errhint("Use FOR EACH ROW for INSTEAD OF triggers")));
! 
! 		/* Disallow WHEN clauses with INSTEAD OF triggers */
! 		if (stmt->instead && stmt->whenClause)
! 			ereport(ERROR,
! 					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 					 errmsg("cannot use a WHEN condition with an INSTEAD OF trigger")));
! 
! 		/* Disallow column selection with INSTEAD OF triggers */
! 		if (stmt->instead && stmt->columns != NIL)
! 			ereport(ERROR,
! 					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 					 errmsg("cannot use a column list with an INSTEAD OF trigger")));
! 	}
! 	else
  		ereport(ERROR,
  				(errcode(ERRCODE_WRONG_OBJECT_TYPE),
! 				 errmsg("\"%s\" is not a table or view",
  						RelationGetRelationName(rel))));
  
  	if (!allowSystemTableMods && IsSystemRelation(rel))
***************
*** 188,193 ****
--- 227,234 ----
  	TRIGGER_CLEAR_TYPE(tgtype);
  	if (stmt->before)
  		TRIGGER_SETT_BEFORE(tgtype);
+ 	if (stmt->instead)
+ 		TRIGGER_SETT_INSTEAD(tgtype);
  	if (stmt->row)
  		TRIGGER_SETT_ROW(tgtype);
  	tgtype |= stmt->events;
***************
*** 198,203 ****
--- 239,252 ----
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
  				 errmsg("TRUNCATE FOR EACH ROW triggers are not supported")));
  
+ 	/* Disallow TRUNCATE triggers on VIEWs */
+ 	if (rel->rd_rel->relkind == RELKIND_VIEW && TRIGGER_FOR_TRUNCATE(tgtype))
+ 		ereport(ERROR,
+ 				(errcode(ERRCODE_WRONG_OBJECT_TYPE),
+ 				 errmsg("\"%s\" is a view",
+ 						RelationGetRelationName(rel)),
+ 				 errhint("Define TRUNCATE triggers on tables")));
+ 
  	/*
  	 * Parse the WHEN clause, if any
  	 */
***************
*** 1031,1040 ****
  
  	rel = heap_open(relid, ShareRowExclusiveLock);
  
! 	if (rel->rd_rel->relkind != RELKIND_RELATION)
  		ereport(ERROR,
  				(errcode(ERRCODE_WRONG_OBJECT_TYPE),
! 				 errmsg("\"%s\" is not a table",
  						RelationGetRelationName(rel))));
  
  	if (!allowSystemTableMods && IsSystemRelation(rel))
--- 1080,1090 ----
  
  	rel = heap_open(relid, ShareRowExclusiveLock);
  
! 	if (rel->rd_rel->relkind != RELKIND_RELATION &&
! 		rel->rd_rel->relkind != RELKIND_VIEW)
  		ereport(ERROR,
  				(errcode(ERRCODE_WRONG_OBJECT_TYPE),
! 				 errmsg("\"%s\" is not a table or view",
  						RelationGetRelationName(rel))));
  
  	if (!allowSystemTableMods && IsSystemRelation(rel))
***************
*** 1506,1511 ****
--- 1556,1566 ----
  			n = trigdesc->n_before_row;
  			t = trigdesc->tg_before_row;
  		}
+ 		else if (TRIGGER_FOR_INSTEAD(trigger->tgtype))
+ 		{
+ 			n = trigdesc->n_instead_row;
+ 			t = trigdesc->tg_instead_row;
+ 		}
  		else
  		{
  			n = trigdesc->n_after_row;
***************
*** 1656,1661 ****
--- 1711,1729 ----
  		else
  			t[i] = NULL;
  	}
+ 	n = newdesc->n_instead_row;
+ 	t = newdesc->tg_instead_row;
+ 	for (i = 0; i < TRIGGER_NUM_EVENT_CLASSES; i++)
+ 	{
+ 		if (n[i] > 0)
+ 		{
+ 			tnew = (int *) palloc(n[i] * sizeof(int));
+ 			memcpy(tnew, t[i], n[i] * sizeof(int));
+ 			t[i] = tnew;
+ 		}
+ 		else
+ 			t[i] = NULL;
+ 	}
  	n = newdesc->n_after_statement;
  	t = newdesc->tg_after_statement;
  	for (i = 0; i < TRIGGER_NUM_EVENT_CLASSES; i++)
***************
*** 1698,1703 ****
--- 1766,1775 ----
  	for (i = 0; i < TRIGGER_NUM_EVENT_CLASSES; i++)
  		if (t[i] != NULL)
  			pfree(t[i]);
+ 	t = trigdesc->tg_instead_row;
+ 	for (i = 0; i < TRIGGER_NUM_EVENT_CLASSES; i++)
+ 		if (t[i] != NULL)
+ 			pfree(t[i]);
  	t = trigdesc->tg_after_statement;
  	for (i = 0; i < TRIGGER_NUM_EVENT_CLASSES; i++)
  		if (t[i] != NULL)
***************
*** 2000,2005 ****
--- 2072,2121 ----
  							  true, NULL, trigtuple, recheckIndexes, NULL);
  }
  
+ HeapTuple
+ ExecIRInsertTriggers(EState *estate, ResultRelInfo *relinfo,
+ 					 HeapTuple trigtuple)
+ {
+ 	TriggerDesc *trigdesc = relinfo->ri_TrigDesc;
+ 	int			ntrigs = trigdesc->n_instead_row[TRIGGER_EVENT_INSERT];
+ 	int		   *tgindx = trigdesc->tg_instead_row[TRIGGER_EVENT_INSERT];
+ 	TriggerData LocTriggerData;
+ 	HeapTuple	newtuple = trigtuple;
+ 	HeapTuple	rettuple;
+ 	int			i;
+ 
+ 	LocTriggerData.type = T_TriggerData;
+ 	LocTriggerData.tg_event = TRIGGER_EVENT_INSERT |
+ 		TRIGGER_EVENT_ROW |
+ 		TRIGGER_EVENT_INSTEAD;
+ 	LocTriggerData.tg_relation = relinfo->ri_RelationDesc;
+ 	for (i = 0; i < ntrigs; i++)
+ 	{
+ 		Trigger    *trigger = &trigdesc->triggers[tgindx[i]];
+ 
+ 		if (!TriggerEnabled(estate, relinfo, trigger, LocTriggerData.tg_event,
+ 							NULL, NULL, trigtuple))
+ 			continue;
+ 
+ 		LocTriggerData.tg_trigtuple = newtuple;
+ 		LocTriggerData.tg_trigtuplebuf = InvalidBuffer;
+ 		LocTriggerData.tg_newtuple = NULL;
+ 		LocTriggerData.tg_newtuplebuf = InvalidBuffer;
+ 		LocTriggerData.tg_trigger = trigger;
+ 		rettuple = ExecCallTriggerFunc(&LocTriggerData,
+ 									   tgindx[i],
+ 									   relinfo->ri_TrigFunctions,
+ 									   relinfo->ri_TrigInstrument,
+ 									   GetPerTupleMemoryContext(estate));
+ 		if (rettuple != newtuple && newtuple != trigtuple)
+ 			heap_freetuple(newtuple);
+ 		newtuple = rettuple;
+ 		if (newtuple == NULL)
+ 			break;
+ 	}
+ 	return newtuple;
+ }
+ 
  void
  ExecBSDeleteTriggers(EState *estate, ResultRelInfo *relinfo)
  {
***************
*** 2134,2139 ****
--- 2250,2297 ----
  	}
  }
  
+ bool
+ ExecIRDeleteTriggers(EState *estate, ResultRelInfo *relinfo,
+ 					 HeapTuple trigtuple)
+ {
+ 	TriggerDesc *trigdesc = relinfo->ri_TrigDesc;
+ 	int			ntrigs = trigdesc->n_instead_row[TRIGGER_EVENT_DELETE];
+ 	int		   *tgindx = trigdesc->tg_instead_row[TRIGGER_EVENT_DELETE];
+ 	TriggerData LocTriggerData;
+ 	HeapTuple	rettuple;
+ 	int			i;
+ 
+ 	LocTriggerData.type = T_TriggerData;
+ 	LocTriggerData.tg_event = TRIGGER_EVENT_DELETE |
+ 		TRIGGER_EVENT_ROW |
+ 		TRIGGER_EVENT_INSTEAD;
+ 	LocTriggerData.tg_relation = relinfo->ri_RelationDesc;
+ 	for (i = 0; i < ntrigs; i++)
+ 	{
+ 		Trigger    *trigger = &trigdesc->triggers[tgindx[i]];
+ 
+ 		if (!TriggerEnabled(estate, relinfo, trigger, LocTriggerData.tg_event,
+ 							NULL, trigtuple, NULL))
+ 			continue;
+ 
+ 		LocTriggerData.tg_trigtuple = trigtuple;
+ 		LocTriggerData.tg_trigtuplebuf = InvalidBuffer;
+ 		LocTriggerData.tg_newtuple = NULL;
+ 		LocTriggerData.tg_newtuplebuf = InvalidBuffer;
+ 		LocTriggerData.tg_trigger = trigger;
+ 		rettuple = ExecCallTriggerFunc(&LocTriggerData,
+ 									   tgindx[i],
+ 									   relinfo->ri_TrigFunctions,
+ 									   relinfo->ri_TrigInstrument,
+ 									   GetPerTupleMemoryContext(estate));
+ 		if (rettuple == NULL)
+ 			return false; /* Delete was suppressed */
+ 		if (rettuple != trigtuple)
+ 			heap_freetuple(rettuple);
+ 	}
+ 	return true;
+ }
+ 
  void
  ExecBSUpdateTriggers(EState *estate, ResultRelInfo *relinfo)
  {
***************
*** 2281,2286 ****
--- 2439,2488 ----
  	}
  }
  
+ HeapTuple
+ ExecIRUpdateTriggers(EState *estate, ResultRelInfo *relinfo,
+ 					 HeapTuple oldtuple, HeapTuple newtuple)
+ {
+ 	TriggerDesc *trigdesc = relinfo->ri_TrigDesc;
+ 	int			ntrigs = trigdesc->n_instead_row[TRIGGER_EVENT_UPDATE];
+ 	int		   *tgindx = trigdesc->tg_instead_row[TRIGGER_EVENT_UPDATE];
+ 	TriggerData LocTriggerData;
+ 	HeapTuple	intuple = newtuple;
+ 	HeapTuple	rettuple;
+ 	int			i;
+ 
+ 	LocTriggerData.type = T_TriggerData;
+ 	LocTriggerData.tg_event = TRIGGER_EVENT_UPDATE |
+ 		TRIGGER_EVENT_ROW |
+ 		TRIGGER_EVENT_INSTEAD;
+ 	LocTriggerData.tg_relation = relinfo->ri_RelationDesc;
+ 	for (i = 0; i < ntrigs; i++)
+ 	{
+ 		Trigger    *trigger = &trigdesc->triggers[tgindx[i]];
+ 
+ 		if (!TriggerEnabled(estate, relinfo, trigger, LocTriggerData.tg_event,
+ 							NULL, oldtuple, newtuple))
+ 			continue;
+ 
+ 		LocTriggerData.tg_trigtuple = oldtuple;
+ 		LocTriggerData.tg_newtuple = newtuple;
+ 		LocTriggerData.tg_trigtuplebuf = InvalidBuffer;
+ 		LocTriggerData.tg_newtuplebuf = InvalidBuffer;
+ 		LocTriggerData.tg_trigger = trigger;
+ 		rettuple = ExecCallTriggerFunc(&LocTriggerData,
+ 									   tgindx[i],
+ 									   relinfo->ri_TrigFunctions,
+ 									   relinfo->ri_TrigInstrument,
+ 									   GetPerTupleMemoryContext(estate));
+ 		if (rettuple != newtuple && newtuple != intuple)
+ 			heap_freetuple(newtuple);
+ 		newtuple = rettuple;
+ 		if (newtuple == NULL)
+ 			break;
+ 	}
+ 	return newtuple;
+ }
+ 
  void
  ExecBSTruncateTriggers(EState *estate, ResultRelInfo *relinfo)
  {
*** ./src/backend/executor/execMain.c.orig	2010-08-15 00:04:31.000000000 +0100
--- ./src/backend/executor/execMain.c	2010-08-15 10:01:37.000000000 +0100
***************
*** 899,908 ****
  							RelationGetRelationName(resultRelationDesc))));
  			break;
  		case RELKIND_VIEW:
! 			ereport(ERROR,
! 					(errcode(ERRCODE_WRONG_OBJECT_TYPE),
! 					 errmsg("cannot change view \"%s\"",
! 							RelationGetRelationName(resultRelationDesc))));
  			break;
  		default:
  			ereport(ERROR,
--- 899,905 ----
  							RelationGetRelationName(resultRelationDesc))));
  			break;
  		case RELKIND_VIEW:
! 			/* OK */
  			break;
  		default:
  			ereport(ERROR,
*** ./src/backend/executor/nodeModifyTable.c.orig	2010-08-19 08:53:10.000000000 +0100
--- ./src/backend/executor/nodeModifyTable.c	2010-09-04 22:53:39.000000000 +0100
***************
*** 149,154 ****
--- 149,200 ----
  }
  
  /* ----------------------------------------------------------------
+  *		ExecCheckViewTriggers
+  *
+  *		If the result relation is a view, check that it has the
+  *		appropriate INSTEAD OF triggers to carry out the current
+  *		operation.
+  * ----------------------------------------------------------------
+  */
+ static void
+ ExecCheckViewTriggers(ResultRelInfo *resultRelInfo,
+ 					  CmdType operation)
+ {
+ 	TriggerDesc	*trigDesc = resultRelInfo->ri_TrigDesc;
+ 
+ 	switch (operation)
+ 	{
+ 		case CMD_INSERT:
+ 			if (!trigDesc ||
+ 				trigDesc->n_instead_row[TRIGGER_EVENT_INSERT] == 0)
+ 				ereport(ERROR,
+ 						(errmsg("cannot insert into a view"),
+ 						 errhint("You need an unconditional ON INSERT DO INSTEAD rule or an INSTEAD OF INSERT trigger.")));
+ 			break;
+ 
+ 		case CMD_UPDATE:
+ 			if (!trigDesc ||
+ 				trigDesc->n_instead_row[TRIGGER_EVENT_UPDATE] == 0)
+ 				ereport(ERROR,
+ 						(errmsg("cannot update a view"),
+ 						 errhint("You need an unconditional ON UPDATE DO INSTEAD rule or an INSTEAD OF UPDATE trigger.")));
+ 			break;
+ 
+ 		case CMD_DELETE:
+ 			if (!trigDesc ||
+ 				trigDesc->n_instead_row[TRIGGER_EVENT_DELETE] == 0)
+ 				ereport(ERROR,
+ 						(errmsg("cannot delete from a view"),
+ 						 errhint("You need an unconditional ON DELETE DO INSTEAD rule or an INSTEAD OF DELETE trigger.")));
+ 			break;
+ 
+ 		default:
+ 			elog(ERROR, "unknown operation");
+ 			break;
+ 	}
+ }
+ 
+ /* ----------------------------------------------------------------
   *		ExecInsert
   *
   *		For INSERT, we have to insert the tuple into the target relation
***************
*** 167,172 ****
--- 213,219 ----
  	Relation	resultRelationDesc;
  	Oid			newId;
  	List	   *recheckIndexes = NIL;
+ 	bool		resultRelIsView;
  
  	/*
  	 * get the heap tuple out of the tuple table slot, making sure we have a
***************
*** 179,184 ****
--- 226,232 ----
  	 */
  	resultRelInfo = estate->es_result_relation_info;
  	resultRelationDesc = resultRelInfo->ri_RelationDesc;
+ 	resultRelIsView = resultRelationDesc->rd_rel->relkind == RELKIND_VIEW;
  
  	/*
  	 * If the result relation has OIDs, force the tuple's OID to zero so that
***************
*** 195,202 ****
  	if (resultRelationDesc->rd_rel->relhasoids)
  		HeapTupleSetOid(tuple, InvalidOid);
  
! 	/* BEFORE ROW INSERT Triggers */
! 	if (resultRelInfo->ri_TrigDesc &&
  		resultRelInfo->ri_TrigDesc->n_before_row[TRIGGER_EVENT_INSERT] > 0)
  	{
  		HeapTuple	newtuple;
--- 243,251 ----
  	if (resultRelationDesc->rd_rel->relhasoids)
  		HeapTupleSetOid(tuple, InvalidOid);
  
! 	/* BEFORE ROW INSERT Triggers (tables only) */
! 	if (!resultRelIsView &&
! 		resultRelInfo->ri_TrigDesc &&
  		resultRelInfo->ri_TrigDesc->n_before_row[TRIGGER_EVENT_INSERT] > 0)
  	{
  		HeapTuple	newtuple;
***************
*** 237,244 ****
  	 * Note: heap_insert returns the tid (location) of the new tuple in the
  	 * t_self field.
  	 */
! 	newId = heap_insert(resultRelationDesc, tuple,
! 						estate->es_output_cid, 0, NULL);
  
  	(estate->es_processed)++;
  	estate->es_lastoid = newId;
--- 286,329 ----
  	 * Note: heap_insert returns the tid (location) of the new tuple in the
  	 * t_self field.
  	 */
! 	if (resultRelIsView)
! 	{
! 		/*
! 		 * INSTEAD OF trigger(s) do the actual insert
! 		 */
! 		HeapTuple	newtuple;
! 
! 		ExecCheckViewTriggers(resultRelInfo, CMD_INSERT);
! 		newtuple = ExecIRInsertTriggers(estate, resultRelInfo, tuple);
! 
! 		if (newtuple == NULL)	/* trigger(s) did nothing */
! 			return NULL;
! 
! 		if (newtuple != tuple)	/* modified by Trigger(s) */
! 		{
! 			/*
! 			 * Put the modified tuple into a slot for convenience of
! 			 * routines below.  We assume the tuple was allocated in
! 			 * per-tuple memory context, and therefore will go away by
! 			 * itself. The tuple table slot should not try to clear it.
! 			 */
! 			TupleTableSlot *newslot = estate->es_trig_tuple_slot;
! 			TupleDesc	tupdesc = RelationGetDescr(resultRelationDesc);
! 
! 			if (newslot->tts_tupleDescriptor != tupdesc)
! 				ExecSetSlotDescriptor(newslot, tupdesc);
! 			ExecStoreTuple(newtuple, newslot, InvalidBuffer, false);
! 			slot = newslot;
! 			tuple = newtuple;
! 		}
! 
! 		newId = InvalidOid;
! 	}
! 	else
! 	{
! 		newId = heap_insert(resultRelationDesc, tuple,
! 							estate->es_output_cid, 0, NULL);
! 	}
  
  	(estate->es_processed)++;
  	estate->es_lastoid = newId;
***************
*** 251,258 ****
  		recheckIndexes = ExecInsertIndexTuples(slot, &(tuple->t_self),
  											   estate);
  
! 	/* AFTER ROW INSERT Triggers */
! 	ExecARInsertTriggers(estate, resultRelInfo, tuple, recheckIndexes);
  
  	list_free(recheckIndexes);
  
--- 336,344 ----
  		recheckIndexes = ExecInsertIndexTuples(slot, &(tuple->t_self),
  											   estate);
  
! 	/* AFTER ROW INSERT Triggers (tables only) */
! 	if (!resultRelIsView)
! 		ExecARInsertTriggers(estate, resultRelInfo, tuple, recheckIndexes);
  
  	list_free(recheckIndexes);
  
***************
*** 268,280 ****
   *		ExecDelete
   *
   *		DELETE is like UPDATE, except that we delete the tuple and no
!  *		index modifications are needed
   *
   *		Returns RETURNING result if any, otherwise NULL.
   * ----------------------------------------------------------------
   */
  static TupleTableSlot *
  ExecDelete(ItemPointer tupleid,
  		   TupleTableSlot *planSlot,
  		   EPQState *epqstate,
  		   EState *estate)
--- 354,372 ----
   *		ExecDelete
   *
   *		DELETE is like UPDATE, except that we delete the tuple and no
!  *		index modifications are needed.
!  *
!  *		When deleting from a table, tupleid identifies the tuple to
!  *		delete and oldtuple is NULL.  When deleting from a view,
!  *		oldtuple is passed to the INSTEAD OF triggers and identifies
!  *		what to delete, and tupleid is invalid.
   *
   *		Returns RETURNING result if any, otherwise NULL.
   * ----------------------------------------------------------------
   */
  static TupleTableSlot *
  ExecDelete(ItemPointer tupleid,
+ 		   HeapTupleHeader oldtuple,
  		   TupleTableSlot *planSlot,
  		   EPQState *epqstate,
  		   EState *estate)
***************
*** 284,298 ****
  	HTSU_Result result;
  	ItemPointerData update_ctid;
  	TransactionId update_xmax;
  
  	/*
  	 * get information on the (current) result relation
  	 */
  	resultRelInfo = estate->es_result_relation_info;
  	resultRelationDesc = resultRelInfo->ri_RelationDesc;
  
! 	/* BEFORE ROW DELETE Triggers */
! 	if (resultRelInfo->ri_TrigDesc &&
  		resultRelInfo->ri_TrigDesc->n_before_row[TRIGGER_EVENT_DELETE] > 0)
  	{
  		bool		dodelete;
--- 376,393 ----
  	HTSU_Result result;
  	ItemPointerData update_ctid;
  	TransactionId update_xmax;
+ 	bool		resultRelIsView;
  
  	/*
  	 * get information on the (current) result relation
  	 */
  	resultRelInfo = estate->es_result_relation_info;
  	resultRelationDesc = resultRelInfo->ri_RelationDesc;
+ 	resultRelIsView = resultRelationDesc->rd_rel->relkind == RELKIND_VIEW;
  
! 	/* BEFORE ROW DELETE Triggers (tables only) */
! 	if (!resultRelIsView &&
! 		resultRelInfo->ri_TrigDesc &&
  		resultRelInfo->ri_TrigDesc->n_before_row[TRIGGER_EVENT_DELETE] > 0)
  	{
  		bool		dodelete;
***************
*** 313,323 ****
  	 * referential integrity updates in serializable transactions.
  	 */
  ldelete:;
! 	result = heap_delete(resultRelationDesc, tupleid,
! 						 &update_ctid, &update_xmax,
! 						 estate->es_output_cid,
! 						 estate->es_crosscheck_snapshot,
! 						 true /* wait for commit */ );
  	switch (result)
  	{
  		case HeapTupleSelfUpdated:
--- 408,443 ----
  	 * referential integrity updates in serializable transactions.
  	 */
  ldelete:;
! 	if (resultRelIsView)
! 	{
! 		/*
! 		 * INSTEAD OF trigger(s) do the actual delete
! 		 */
! 		HeapTupleData tuple;
! 		bool		diddelete;
! 
! 		tuple.t_data = oldtuple;
! 		tuple.t_len = HeapTupleHeaderGetDatumLength(oldtuple);
! 		ItemPointerSetInvalid(&(tuple.t_self));
! 		tuple.t_tableOid = InvalidOid;
! 
! 		ExecCheckViewTriggers(resultRelInfo, CMD_DELETE);
! 		diddelete = ExecIRDeleteTriggers(estate, resultRelInfo, &tuple);
! 
! 		if (!diddelete)		/* trigger(s) did nothing */
! 			return NULL;
! 
! 		result = HeapTupleMayBeUpdated;
! 	}
! 	else
! 	{
! 		result = heap_delete(resultRelationDesc, tupleid,
! 							 &update_ctid, &update_xmax,
! 							 estate->es_output_cid,
! 							 estate->es_crosscheck_snapshot,
! 							 true /* wait for commit */ );
! 	}
! 
  	switch (result)
  	{
  		case HeapTupleSelfUpdated:
***************
*** 367,374 ****
  	 * anyway, since the tuple is still visible to other transactions.
  	 */
  
! 	/* AFTER ROW DELETE Triggers */
! 	ExecARDeleteTriggers(estate, resultRelInfo, tupleid);
  
  	/* Process RETURNING if present */
  	if (resultRelInfo->ri_projectReturning)
--- 487,495 ----
  	 * anyway, since the tuple is still visible to other transactions.
  	 */
  
! 	/* AFTER ROW DELETE Triggers (tables only) */
! 	if (!resultRelIsView)
! 		ExecARDeleteTriggers(estate, resultRelInfo, tupleid);
  
  	/* Process RETURNING if present */
  	if (resultRelInfo->ri_projectReturning)
***************
*** 382,391 ****
  		HeapTupleData deltuple;
  		Buffer		delbuffer;
  
! 		deltuple.t_self = *tupleid;
! 		if (!heap_fetch(resultRelationDesc, SnapshotAny,
! 						&deltuple, &delbuffer, false, NULL))
! 			elog(ERROR, "failed to fetch deleted tuple for DELETE RETURNING");
  
  		if (slot->tts_tupleDescriptor != RelationGetDescr(resultRelationDesc))
  			ExecSetSlotDescriptor(slot, RelationGetDescr(resultRelationDesc));
--- 503,522 ----
  		HeapTupleData deltuple;
  		Buffer		delbuffer;
  
! 		if (resultRelIsView)
! 		{
! 			deltuple.t_data = oldtuple;
! 			deltuple.t_len = HeapTupleHeaderGetDatumLength(oldtuple);
! 			ItemPointerSetInvalid(&(deltuple.t_self));
! 			deltuple.t_tableOid = InvalidOid;
! 		}
! 		else
! 		{
! 			deltuple.t_self = *tupleid;
! 			if (!heap_fetch(resultRelationDesc, SnapshotAny,
! 							&deltuple, &delbuffer, false, NULL))
! 				elog(ERROR, "failed to fetch deleted tuple for DELETE RETURNING");
! 		}
  
  		if (slot->tts_tupleDescriptor != RelationGetDescr(resultRelationDesc))
  			ExecSetSlotDescriptor(slot, RelationGetDescr(resultRelationDesc));
***************
*** 395,401 ****
  									 slot, planSlot);
  
  		ExecClearTuple(slot);
! 		ReleaseBuffer(delbuffer);
  
  		return rslot;
  	}
--- 526,533 ----
  									 slot, planSlot);
  
  		ExecClearTuple(slot);
! 		if (!resultRelIsView)
! 			ReleaseBuffer(delbuffer);
  
  		return rslot;
  	}
***************
*** 413,423 ****
--- 545,561 ----
   *		is, we don't want to get stuck in an infinite loop
   *		which corrupts your database..
   *
+  *		When updating a table, tupleid identifies the tuple to
+  *		update and oldtuple is NULL.  When updating a view, oldtuple
+  *		is passed to the INSTEAD OF triggers and identifies what to
+  *		update, and tupleid is invalid.
+  *
   *		Returns RETURNING result if any, otherwise NULL.
   * ----------------------------------------------------------------
   */
  static TupleTableSlot *
  ExecUpdate(ItemPointer tupleid,
+ 		   HeapTupleHeader oldtuple,
  		   TupleTableSlot *slot,
  		   TupleTableSlot *planSlot,
  		   EPQState *epqstate,
***************
*** 430,435 ****
--- 568,574 ----
  	ItemPointerData update_ctid;
  	TransactionId update_xmax;
  	List	   *recheckIndexes = NIL;
+ 	bool		resultRelIsView;
  
  	/*
  	 * abort the operation if not running transactions
***************
*** 448,456 ****
  	 */
  	resultRelInfo = estate->es_result_relation_info;
  	resultRelationDesc = resultRelInfo->ri_RelationDesc;
  
! 	/* BEFORE ROW UPDATE Triggers */
! 	if (resultRelInfo->ri_TrigDesc &&
  		resultRelInfo->ri_TrigDesc->n_before_row[TRIGGER_EVENT_UPDATE] > 0)
  	{
  		HeapTuple	newtuple;
--- 587,597 ----
  	 */
  	resultRelInfo = estate->es_result_relation_info;
  	resultRelationDesc = resultRelInfo->ri_RelationDesc;
+ 	resultRelIsView = resultRelationDesc->rd_rel->relkind == RELKIND_VIEW;
  
! 	/* BEFORE ROW UPDATE Triggers (tables only) */
! 	if (!resultRelIsView &&
! 		resultRelInfo->ri_TrigDesc &&
  		resultRelInfo->ri_TrigDesc->n_before_row[TRIGGER_EVENT_UPDATE] > 0)
  	{
  		HeapTuple	newtuple;
***************
*** 501,511 ****
  	 * serialize error if not.	This is a special-case behavior needed for
  	 * referential integrity updates in serializable transactions.
  	 */
! 	result = heap_update(resultRelationDesc, tupleid, tuple,
! 						 &update_ctid, &update_xmax,
! 						 estate->es_output_cid,
! 						 estate->es_crosscheck_snapshot,
! 						 true /* wait for commit */ );
  	switch (result)
  	{
  		case HeapTupleSelfUpdated:
--- 642,696 ----
  	 * serialize error if not.	This is a special-case behavior needed for
  	 * referential integrity updates in serializable transactions.
  	 */
! 	if (resultRelIsView)
! 	{
! 		/*
! 		 * INSTEAD OF trigger(s) do the actual update
! 		 */
! 		HeapTupleData oldtup;
! 		HeapTuple	newtuple;
! 
! 		oldtup.t_data = oldtuple;
! 		oldtup.t_len = HeapTupleHeaderGetDatumLength(oldtuple);
! 		ItemPointerSetInvalid(&(oldtup.t_self));
! 		oldtup.t_tableOid = InvalidOid;
! 
! 		ExecCheckViewTriggers(resultRelInfo, CMD_UPDATE);
! 		newtuple = ExecIRUpdateTriggers(estate, resultRelInfo,
! 										&oldtup, tuple);
! 
! 		if (newtuple == NULL)	/* trigger(s) did nothing */
! 			return NULL;
! 
! 		if (newtuple != tuple)	/* modified by Trigger(s) */
! 		{
! 			/*
! 			 * Put the modified tuple into a slot for convenience of
! 			 * routines below.  We assume the tuple was allocated in
! 			 * per-tuple memory context, and therefore will go away by
! 			 * itself. The tuple table slot should not try to clear it.
! 			 */
! 			TupleTableSlot *newslot = estate->es_trig_tuple_slot;
! 			TupleDesc	tupdesc = RelationGetDescr(resultRelationDesc);
! 
! 			if (newslot->tts_tupleDescriptor != tupdesc)
! 				ExecSetSlotDescriptor(newslot, tupdesc);
! 			ExecStoreTuple(newtuple, newslot, InvalidBuffer, false);
! 			slot = newslot;
! 			tuple = newtuple;
! 		}
! 
! 		result = HeapTupleMayBeUpdated;
! 	}
! 	else
! 	{
! 		result = heap_update(resultRelationDesc, tupleid, tuple,
! 							 &update_ctid, &update_xmax,
! 							 estate->es_output_cid,
! 							 estate->es_crosscheck_snapshot,
! 							 true /* wait for commit */ );
! 	}
! 
  	switch (result)
  	{
  		case HeapTupleSelfUpdated:
***************
*** 568,576 ****
  		recheckIndexes = ExecInsertIndexTuples(slot, &(tuple->t_self),
  											   estate);
  
! 	/* AFTER ROW UPDATE Triggers */
! 	ExecARUpdateTriggers(estate, resultRelInfo, tupleid, tuple,
! 						 recheckIndexes);
  
  	list_free(recheckIndexes);
  
--- 753,762 ----
  		recheckIndexes = ExecInsertIndexTuples(slot, &(tuple->t_self),
  											   estate);
  
! 	/* AFTER ROW UPDATE Triggers (tables only) */
! 	if (!resultRelIsView)
! 		ExecARUpdateTriggers(estate, resultRelInfo, tupleid, tuple,
! 							 recheckIndexes);
  
  	list_free(recheckIndexes);
  
***************
*** 654,659 ****
--- 840,846 ----
  	TupleTableSlot *planSlot;
  	ItemPointer tupleid = NULL;
  	ItemPointerData tuple_ctid;
+ 	HeapTupleHeader	oldtuple;
  
  	/*
  	 * On first call, fire BEFORE STATEMENT triggers before proceeding.
***************
*** 713,735 ****
  
  		if (junkfilter != NULL)
  		{
  			/*
! 			 * extract the 'ctid' junk attribute.
  			 */
  			if (operation == CMD_UPDATE || operation == CMD_DELETE)
  			{
  				Datum		datum;
  				bool		isNull;
  
! 				datum = ExecGetJunkAttribute(slot, junkfilter->jf_junkAttNo,
! 											 &isNull);
! 				/* shouldn't ever get a null result... */
! 				if (isNull)
! 					elog(ERROR, "ctid is NULL");
! 
! 				tupleid = (ItemPointer) DatumGetPointer(datum);
! 				tuple_ctid = *tupleid;	/* be sure we don't free the ctid!! */
! 				tupleid = &tuple_ctid;
  			}
  
  			/*
--- 900,936 ----
  
  		if (junkfilter != NULL)
  		{
+ 			ResultRelInfo  *resultRelInfo = estate->es_result_relation_info;
+ 			Relation		resultRel = resultRelInfo->ri_RelationDesc;
+ 
  			/*
! 			 * extract the 'ctid' or 'wholerow' junk attribute.
  			 */
  			if (operation == CMD_UPDATE || operation == CMD_DELETE)
  			{
  				Datum		datum;
  				bool		isNull;
  
! 				if (resultRel->rd_rel->relkind == RELKIND_VIEW)
! 				{
! 					datum = ExecGetJunkAttribute(slot, junkfilter->jf_junkAttNo,
! 												 &isNull);
! 					if (isNull)
! 						elog(ERROR, "wholerow is NULL");
! 
! 					oldtuple = DatumGetHeapTupleHeader(datum);
! 				}
! 				else
! 				{
! 					datum = ExecGetJunkAttribute(slot, junkfilter->jf_junkAttNo,
! 												 &isNull);
! 					if (isNull)
! 						elog(ERROR, "ctid is NULL");
! 
! 					tupleid = (ItemPointer) DatumGetPointer(datum);
! 					tuple_ctid = *tupleid;	/* be sure we don't free the ctid!! */
! 					tupleid = &tuple_ctid;
! 				}
  			}
  
  			/*
***************
*** 745,755 ****
  				slot = ExecInsert(slot, planSlot, estate);
  				break;
  			case CMD_UPDATE:
! 				slot = ExecUpdate(tupleid, slot, planSlot,
  								  &node->mt_epqstate, estate);
  				break;
  			case CMD_DELETE:
! 				slot = ExecDelete(tupleid, planSlot,
  								  &node->mt_epqstate, estate);
  				break;
  			default:
--- 946,956 ----
  				slot = ExecInsert(slot, planSlot, estate);
  				break;
  			case CMD_UPDATE:
! 				slot = ExecUpdate(tupleid, oldtuple, slot, planSlot,
  								  &node->mt_epqstate, estate);
  				break;
  			case CMD_DELETE:
! 				slot = ExecDelete(tupleid, oldtuple, planSlot,
  								  &node->mt_epqstate, estate);
  				break;
  			default:
***************
*** 833,838 ****
--- 1034,1043 ----
  	i = 0;
  	foreach(l, node->plans)
  	{
+ 		Relation resultRel = estate->es_result_relation_info->ri_RelationDesc;
+ 		if (resultRel->rd_rel->relkind == RELKIND_VIEW)
+ 			ExecCheckViewTriggers(estate->es_result_relation_info, operation);
+ 
  		subplan = (Plan *) lfirst(l);
  		mtstate->mt_plans[i] = ExecInitNode(subplan, estate, eflags);
  		estate->es_result_relation_info++;
***************
*** 988,997 ****
  
  				if (operation == CMD_UPDATE || operation == CMD_DELETE)
  				{
! 					/* For UPDATE/DELETE, find the ctid junk attr now */
! 					j->jf_junkAttNo = ExecFindJunkAttribute(j, "ctid");
! 					if (!AttributeNumberIsValid(j->jf_junkAttNo))
! 						elog(ERROR, "could not find junk ctid column");
  				}
  
  				resultRelInfo->ri_junkFilter = j;
--- 1193,1216 ----
  
  				if (operation == CMD_UPDATE || operation == CMD_DELETE)
  				{
! 					/*
! 					 * For UPDATE/DELETE of real tables, find the ctid junk
! 					 * attr now. For VIEWs use the wholerow junk attr.
! 					 */
! 					Relation resultRel = resultRelInfo->ri_RelationDesc;
! 
! 					if (resultRel->rd_rel->relkind == RELKIND_VIEW)
! 					{
! 						j->jf_junkAttNo = ExecFindJunkAttribute(j, "wholerow");
! 						if (!AttributeNumberIsValid(j->jf_junkAttNo))
! 							elog(ERROR, "could not find junk wholerow column");
! 					}
! 					else
! 					{
! 						j->jf_junkAttNo = ExecFindJunkAttribute(j, "ctid");
! 						if (!AttributeNumberIsValid(j->jf_junkAttNo))
! 							elog(ERROR, "could not find junk ctid column");
! 					}
  				}
  
  				resultRelInfo->ri_junkFilter = j;
*** ./src/backend/nodes/copyfuncs.c.orig	2010-08-19 08:55:28.000000000 +0100
--- ./src/backend/nodes/copyfuncs.c	2010-08-19 08:55:27.000000000 +0100
***************
*** 3229,3234 ****
--- 3229,3235 ----
  	COPY_NODE_FIELD(funcname);
  	COPY_NODE_FIELD(args);
  	COPY_SCALAR_FIELD(before);
+ 	COPY_SCALAR_FIELD(instead);
  	COPY_SCALAR_FIELD(row);
  	COPY_SCALAR_FIELD(events);
  	COPY_NODE_FIELD(columns);
*** ./src/backend/nodes/equalfuncs.c.orig	2010-08-19 08:56:51.000000000 +0100
--- ./src/backend/nodes/equalfuncs.c	2010-08-19 08:56:50.000000000 +0100
***************
*** 1686,1691 ****
--- 1686,1692 ----
  	COMPARE_NODE_FIELD(funcname);
  	COMPARE_NODE_FIELD(args);
  	COMPARE_SCALAR_FIELD(before);
+ 	COMPARE_SCALAR_FIELD(instead);
  	COMPARE_SCALAR_FIELD(row);
  	COMPARE_SCALAR_FIELD(events);
  	COMPARE_NODE_FIELD(columns);
*** ./src/backend/optimizer/plan/planmain.c.orig	2010-07-28 09:37:12.000000000 +0100
--- ./src/backend/optimizer/plan/planmain.c	2010-08-15 09:29:08.000000000 +0100
***************
*** 180,185 ****
--- 180,194 ----
  	add_base_rels_to_query(root, (Node *) parse->jointree);
  
  	/*
+ 	 * If the query target is a VIEW, it won't be in the jointree, but we
+ 	 * need a dummy RelOptInfo node for it. This need not have any stats in
+ 	 * it because it always just goes at the top of the plan tree.
+ 	 */
+ 	if (parse->resultRelation &&
+ 		root->simple_rel_array[parse->resultRelation] == NULL)
+ 		build_simple_rel(root, parse->resultRelation, RELOPT_OTHER_MEMBER_REL);
+ 
+ 	/*
  	 * Examine the targetlist and qualifications, adding entries to baserel
  	 * targetlists for all referenced Vars.  Restrict and join clauses are
  	 * added to appropriate lists belonging to the mentioned relations.  We
